package main

import (
	"go.wit.com/lib/protobuf/gitpb"
	"go.wit.com/log"
)

func doScan() {
	me.forge.ScanGoSrc()
}

func doGitPull() {
	allerr := me.found.RillGitPull(40, 5)

	all := me.found.SortByGoPath()
	for all.Scan() {
		repo := all.Next()
		result := allerr[repo]
		if result.Error == gitpb.ErrorGitPullOnDirty {
			log.Info("skip git pull. repo is dirty", repo.GoPath)
			continue
		}
		if result.Error == gitpb.ErrorGitPullOnLocal {
			log.Info("skip git pull. local branch ", repo.GoPath)
			continue
		}
		if result.Exit == 0 {
			continue
		}

		log.Info("git pull error:", repo.GoPath, result.Error)
		log.Info("git pull error:", repo.GoPath, result.Stdout)
	}

}

func doFix() {
	var fixed bool = false
	all := me.found.SortByGoPath()
	for all.Scan() {
		repo := all.Next()
		if !repo.IsValid() {
			log.Printf("%10s %-50s", "old?\n", repo.GoPath)
			me.forge.Repos.DeleteByGoPath(repo.GoPath)
			fixed = true
			continue
		}
		log.Printf("running on: %-50s\n", repo.GetGoPath())
		cmd := []string{"ls"}
		repo.Run(cmd)
	}
	if fixed {
		me.forge.Repos.ConfigSave()
		okExit("config saved")
	}
}
